Redmine - Feature #29712

Preview and wiki toolbar for full width custom fields
2018-10-02 09:12 - Go MAEDA

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Go MAEDA % Done: 0%
Category: Custom fields Estimated time: 0.00 hour
Target version: 4.1.0

Resolution: Fixed

Description

Currently, full-width custom fields don't have preview feature and wiki toolbar.

Since those look like a description field, | think it would be great and makes Ul consistent to have preview and toolbar.

New issue
Project * eCookbook [T
Tracker * Bug [T
Subject *
Description . i
Edit | Preview B || 1 J || 8 il > | H3 = ||i= = =
Status * New [~
Priority * Normal [T ]
Assignee [T
cf-fullwidth
Related issues:
Related to Redmine - Feature #27758: Adds preview option to the wiki toolbar Closed
Related to Redmine - Feature #21924: Formatting buttons on long text custom f... Closed
Has duplicate Redmine - Feature #28085: Wiki Toolbar on Full Width Custom Fields Closed
Has duplicate Redmine - Defect #30745: Rich text formatting is broken on Text... Closed

Associated revisions

Revision 17858 - 2019-02-12 12:50 - Go MAEDA
Show Edit/Preview tabs for full width layout custom fields with text formatting enabled (#29712).
Patch by Marius BALTEANU.

Revision 17859 - 2019-02-12 12:52 - Go MAEDA

Refactor custom field value tag for custom fields with full text formatting enabled (#29712).

Patch by Marius BALTEANU.

History

#1 - 2018-10-02 09:32 - Go MAEDA
- Related to Feature #28085: Wiki Toolbar on Full Width Custom Fields added

#2 - 2018-10-07 02:37 - Go MAEDA
- Related to Feature #27758: Adds preview option to the wiki toolbar added

#3 - 2018-10-11 06:22 - Mizuki ISHIKAWA

- File feature-29712.patch added

By applying this patch preview and toolbar will be added to the full width IssueCustomField.

Full width custom fields often write long sentences, and previews and toolbars can help with that input.

#4 - 2018-10-11 06:34 - Mizuki ISHIKAWA
- File feature-29712-v2.patch added

Previous patch included unnecessary code, so | fixed it.
Please delete the previous patch.

#5 - 2018-10-11 06:47 - Go MAEDA
- File deleted (feature-29712.patch)

#6 - 2018-10-11 11:24 - Marius BALTEANU

Thanks Mizuki for working on this. One question after | took a look at the patch without actually testing it, why we limit this feature only to Issue
custom fields? | think we should have the toolbar wherever the text formatting is supported.

#7 - 2018-10-12 04:43 - Mizuki ISHIKAWA
Marius BALTEANU wrote:
Thanks Mizuki for working on this. One question after | took a look at the patch without actually testing it, why we limit this feature only to Issue

custom fields? | think we should have the toolbar wherever the text formatting is supported.

Thank you for your feedback. | had overlooked it.
I will fix the patch.

#8 - 2018-10-15 06:21 - Mizuki ISHIKAWA

- File feature-29712-v3.patch added

| wrote a patch to add a Wiki toolbar in other custom fields.

UserCustomField, TimeEntryActivityCustomField, and IssueCustomField(full_width_layout? == false) do not fit in the Wiki toolbar because the width

of the input field is not the full width.
Therefore, this patch does not display the Wiki toolbar for these custom fields.

#9 - 2018-10-28 21:46 - Marius BALTEANU
Mizuki ISHIKAWA wrote:
| wrote a patch to add a Wiki toolbar in other custom fields.
UserCustomField, TimeEntryActivityCustomField, and IssueCustomField(full_width_layout? == false) do not fit in the Wiki toolbar because the

width of the input field is not the full width.
Therefore, this patch does not display the Wiki toolbar for these custom fields.
Thanks again for working on this. Today | had some time to look over the proposed patch and | am almost sure that we should not touch the
FieldFormat module to implement this feature.

| propose the following directions to implement this:

1. Call wikitoolbar_for from issues/_form_custom_fields.html.erb

-—— a/app/helpers/custom_fields_helper.rb
+++ b/app/helpers/custom_fields_helper.rb
@@ -79,11 +79,18 @@ module CustomFieldsHelper

# Return custom field html tag corresponding to its format
def custom_field_tag(prefix, custom_value)

-—- a/app/views/issues/_form_custom_fields.html.erb

+++ b/app/views/issues/_form_custom_fields.html.erb

@@ -20,4 +20,5 @@

<% custom_field_values_full_width.each do |value| %>
<p><%= custom_field_tag_with_label :issue, value, :required => (@issue.required_attribute? (value.custom_fiel
d_id) %></p>
+ <%= wikitoolbar_for "issue_custom_field_values_#{value.custom_field_id}", preview_issue_path (:project_id =>
@issue.project, :issue_id => @issue.id) %>
<% end %>

2. Add 'wiki-edit' class to field from custom_fields_helper.rb

-—— a/app/helpers/custom_fields_helper.rb
+++ b/app/helpers/custom_fields_helper.rb
@@ -79,11 +79,18 Q@ module CustomFieldsHelper

# Return custom field html tag corresponding to its format
def custom_field_tag(prefix, custom_value)
css = "#{custom_value.custom_field.field_format}_cf"
cf_format_store = custom_value.custom_field.format_store
if cf_format_store.key? ('text_formatting') && cf_format_store['text_formatting'] =
cf_format_store.key? ('full_width_layout') && cf_format_store['full_width_layout'
css << ' wiki-edit'

—
Il
Il
=

end

+ + + + + + +

custom_value.custom_field.format.edit_tag self,
custom_field tag_id(prefix, custom_value.custom_field),
custom_field_tag_name (prefix, custom_value.custom_field),
custom_value,
f :class => "#{custom_value.custom_field.field format}_cf"
+ :class => css
end

Initially, | wanted to add the 'wiki-edit' class also from the view (together with the required attribute, but the custom_field_label_tag do not pass the
options variable to custom_field_tag. Maybe it is better to modify these 2 functions instead of the solution from the above diff because will keep the
code clearer (those 4 conditions do not look to well).

00 D, what do you think?

#10 - 2018-10-28 21:55 - Marius BALTEANU
- Related to deleted (Feature #28085: Wiki Toolbar on Full Width Custom Fields)

#11 - 2018-10-28 21:56 - Marius BALTEANU
- Has duplicate Feature #28085: Wiki Toolbar on Full Width Custom Fields added

#12 - 2018-10-28 22:17 - Marius BALTEANU
Marius BALTEANU wrote:

2. Add 'wiki-edit' class to field from custom_fields_helper.rb
[]

I'm blind, sorry. We should use the existing method full_width_layout? instead of the 4 conditions.
In the end, it could look something like this:
css << wiki-edit' if custom_value.custom_field.full _width_layout?

#13 - 2018-10-31 01:35 - Mizuki ISHIKAWA
#297124#note-9 code looks better than changing the FieldFormat module.
Custom fields other than IssueCustomFields do not have full_width_layout.

(http://www.redmine.org/projects/redmine/repository/entry/trunk/app/views/custom_fields/formats/_text.html.erb#L 4)
If possible, | think that it is better to display the toolbar in other custom fields as well.

#14 - 2018-11-05 03:01 - Go MAEDA

- Target version set to Candidate for next major release

#15 - 2019-02-03 21:38 - Marius BALTEANU
- File 0001-Show-Edit-Preview-tabs-for-full-width-layout-custom-.patch added

Implemented for full width layout custom fields.

#16 - 2019-02-05 20:17 - Marius BALTEANU

- File 0002-Refactor-custom-field-value-tag-for-custom-fields-wi.patch added

Applying my previous patch, will allow us to refactor a small piece of code that adds the 'wiki' class to the issues custom fields with text formatting
enabled (including my fix for #30027). I'm attaching the patch.

#17 - 2019-02-05 20:20 - Marius BALTEANU

Mizuki ISHIKAWA wrote:
#29712#note-9 code looks better than changing the FieldFormat module.
Custom fields other than IssueCustomFields do not have full_width_layout.

(http://www.redmine.org/projects/redmine/repository/entry/trunk/app/views/custom_fields/formats/_text.html.erb#L4)
If possible, | think that it is better to display the toolbar in other custom fields as well.

Agree, we should show to toolbar for all custom fields that support full text formatting, but | prefer to do it in another ticket because it require more
changes.

#18 - 2019-02-06 09:56 - Marius BALTEANU
- Has duplicate Defect #30745: Rich text formatting is broken on Text and Long text custom fields added

#19 - 2019-02-12 11:13 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

LGTM. Setting the target version to 4.1.0.

#20 - 2019-02-12 12:53 - Go MAEDA
- Status changed from New to Closed
- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you all for working on improving Redmine.

#21 - 2021-03-11 14:27 - Go MAEDA
- Related to Feature #21924: Formatting buttons on long text custom fields added

Files

preview-and-toolbar@2x.png 37.5 KB 2018-10-02 Go MAEDA
feature-29712-v2.patch 2.34 KB 2018-10-11 Mizuki ISHIKAWA
feature-29712-v3.patch 4.59 KB 2018-10-15 Mizuki ISHIKAWA
0001-Show-Edit-Preview-tabs-for-full-width-layout-custom-.patch 4.88 KB 2019-02-03 Marius BALTEANU
0002-Refactor-custom-field-value-tag-for-custom-fields-wi.patch 2.67 KB 2019-02-05 Marius BALTEANU
